"""Initial setup

Revision ID: 1e0a9d82ddc3
Revises: None
Create Date: 2012-09-25 17:43:11.860161

"""

# revision identifiers, used by Alembic.
revision = '1e0a9d82ddc3'
down_revision = None

from alembic import op
import sqlalchemy as sa


def downgrade():
    ### commands auto generated by Alembic - please adjust! ###
    op.drop_table(u'shared_folder')
    op.drop_table(u'access_statistics')
    op.drop_table(u'user')
    op.drop_table(u'workspace')
    op.drop_table(u'shared_folder_allocation')
    ### end Alembic commands ###


def upgrade():
    ### commands auto generated by Alembic - please adjust! ###
    op.create_table(u'shared_folder_allocation',
    sa.Column(u'folder_id', sa.INTEGER(), nullable=False),
    sa.Column(u'user_id', sa.INTEGER(), nullable=False),
    sa.ForeignKeyConstraint(['folder_id'], [u'shared_folder.id'], ),
    sa.ForeignKeyConstraint(['user_id'], [u'user.id'], ),
    sa.PrimaryKeyConstraint(u'folder_id', u'user_id')
    )
    op.create_table(u'workspace',
    sa.Column(u'id', sa.INTEGER(), nullable=False, primary_key=True),
    sa.Column(u'name', sa.UnicodeText(), nullable=False),
    sa.Column(u'host', sa.UnicodeText(), nullable=False),
    sa.Column(u'login', sa.UnicodeText(), nullable=True),
    sa.Column(u'key', sa.UnicodeText(), nullable=False),
    sa.Column(u'password', sa.UnicodeText(), nullable=False),
    sa.Column(u'command', sa.UnicodeText(), nullable=False),
    sa.Column(u'basedir', sa.UnicodeText(), nullable=False),
    )
    op.create_table(u'user',
    sa.Column(u'id', sa.INTEGER(), nullable=False, primary_key=True),
    sa.Column(u'name', sa.UnicodeText(), nullable=False),
    sa.Column(u'password', sa.UnicodeText(), nullable=False),
    sa.Column(u'email', sa.UnicodeText(), nullable=False),
    sa.Column(u'created', sa.DATETIME(), nullable=False),
    sa.Column(u'last_request', sa.UnicodeText(), nullable=False),
    sa.Column(u'status', sa.INTEGER(), nullable=False),
    )
    op.create_table(u'access_statistics',
    sa.Column(u'id', sa.INTEGER(), nullable=False, primary_key=True),
    sa.Column(u'user_ip', sa.UnicodeText(), nullable=False),
    sa.Column(u'user_agent', sa.UnicodeText(), nullable=False),
    sa.Column(u'date', sa.DATE(), nullable=False),
    sa.Column(u'pis', sa.INTEGER(), nullable=False),
    )
    op.create_table(u'shared_folder',
    sa.Column(u'id', sa.INTEGER(), nullable=False, primary_key=True),
    sa.Column(u'name', sa.UnicodeText(), nullable=False),
    sa.Column(u'created', sa.DATETIME(), nullable=False),
    )
    ### end Alembic commands ###
